{$INCLUDE Options.Inc}
unit NpsUrl;
items{
*************** Freeware Freeware Freeware ********************************
*	Name:					NpsUrl.PAS																								*
*	Description:	URL support																								*
*	Platform:			Delphi 2.0																								*
*	Files:				NpsUrl.dcu	# component (compiled)												*
*								NpsUrl.dcr	# component resource file											*
*								NpsUrl.res	# component resource file											*
*								NpsUrl.hlp	* component help file													*
*								NpsUrl.kwf	* component resource file											*
*								NpsUrl.pas	- component source 														*
*								Options.Inc	- Compiler's directives												*
*	Author:				Anatoly Podgoretsky																				*
*								Vahe 4-31, Johvi, Estonia, EE2045													*
*								kvk@estpak.ee																							*
*	Main authors:	Ahto Tanner and Per-Eric Larsson													*
*	Installation:	Copy files marked with <#> in your prefered component			*
*								directory or create new one. Then install on palette			*
*								<Component|Install>. Component installed on ADD tab.			*
*								If this tab not fine for you may change it.								*
*								look comment in Register procedure												*
*								* copy these files into help directory and install help		*
*								and copy all files into source directory (NPSURL)					*
*	Editor:				Tabs step = 2, Courier New																*
*	Started:			05.04.97 - Initial release																*
*	Changed:			11.06.97 - renamed from UrlLabel to NpsUrl								*
***************************************************************************
*	Copyright:		Ahto Tanner, Moon Software	(UrlLabel)										*
*											http://www.estpak.ee/~ahto/													*
*											moon@kagi.com																				*
*	Copyright:		Per-Eric Larsson (MailToLabel)														*
*											per-eric.larsson@boras.mail.telia.com								*
*	Copyright:		() NPS, 1997																							*
***************************************************************************
*	This programm fully free and may use and distribute as you want, except	*
* Copyright notice, this must stay unchanged. Of couse if you modify			*
* programm you may add yours Portion Copyright statement below us. Also		*
* state our names in a credits section of your program and use it as you	*
* like.																																		*
***************************************************************************
}
interface

uses
  Windows,
  Classes,
  Forms,
  StdCtrls,
  ShellAPI,
  Graphics,
  Controls;
const
  crHand	= 5;
type
	TProtocol	=	(ptNONE,ptMAIL,ptWWW,ptFTP,ptFILE);
	TNpsUrl = class(TLabel)
		private
			FUrl					: string;
			FProtocol			: TProtocol;
			FActiveColor	: TColor;
    	FPassiveColor	: TColor;
    public
    	constructor Create(AOwner:TComponent);	override;
    	destructor 	Destroy;										override;
	    procedure		Click; 											override;
  	  procedure 	MouseDown(Button:TMouseButton;
      											Shift:TShiftState;
                            X,Y:Integer); 		override;
    	procedure 	MouseUp(Button:TMouseButton;
      										Shift:TShiftState;
													X,Y:Integer);				override;
		published
    	property Protocol			: TProtocol	read		FProtocol
	      																write 	FProtocol
                                        default	ptMAIL;
    	property Url					: string		read		FUrl
      																	write 	FUrl;
	    property ActiveColor	: TColor		read		FActiveColor
      																	write 	FActiveColor
                                      	default clPurple;
	end;	// TNpsUrl

procedure Register;

implementation

{$R NpsUrl.res}

const
  Protocol_Strings : array [TProtocol] of string = ('',
  																									'mailto:',
                                                    'http://',
                                                    'ftp://',
                                                    'file:');
// if need additional service add it here and new enumerated type into TProtocol

{************************************
 * Create component, setup defaults	*
 ************************************}
constructor TNpsUrl.Create(AOwner:TComponent);
begin
	inherited Create(AOwner);
  Screen.Cursors[crHand]	:= LoadCursor(HInstance,PChar('HAND'));
  Cursor									:= crHand;
  FActiveColor						:= clPurple;
  FProtocol								:= ptMAIL;
  FUrl										:= 'kvk@estpak.ee';
  Caption									:= FUrl;
  with Font do begin
  	Size	:= 12;
    Color := clBlue;
		Style := [fsUnderline];
  end;
end;	// Create
{**********************
 * Destroy component	*
 **********************}
destructor TNpsUrl.Destroy;
begin
  inherited Destroy;
end;	// Destroy
{********************
 * OnClick handler	*
 ********************}
procedure TNpsUrl.Click;
var
	Tmp	:	string;
begin
	if Enabled then begin
		inherited Click;
	  Tmp := Protocol_Strings[Protocol];
  	if Pos(Tmp, Url) = 1 then Tmp := '';
		ShellExecute(Application.Handle,'open',PChar(Tmp + Url),nil,nil,SW_NORMAL);
  end;
end;	// Click
{********************************
 * OnMouseDown event handler		*
 * change color to ActiveColor	*
 ********************************}
procedure TNpsUrl.MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
begin
	if Enabled and (Button = mbLeft) then begin
    FPassiveColor := Font.Color;						// save current color
    Font.Color 		:= FActiveColor;					// change to Active
	 inherited;
 end;
end;	// MouseDown
{**********************************
 * OnMouseUp event handler				*
 * restored color to PassiveColor	*
 **********************************}
procedure TNpsUrl.MouseUp(Button:TMouseButton; Shift:TShiftState; X,Y:Integer);
begin
  if Enabled and (Button = mbLeft) then begin
  	Font.Color := FPassiveColor;	// restore color
	  inherited;
  end;
end;	// MouseUp
{************************************************************************
 * Component registration, change section name for you favorite Add In	*
 ************************************************************************}
procedure Register;
begin
  RegisterComponents('Add',[TNpsUrl]);
end;	// Register

end.
